{$A+,B-,C-,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y-,Z1}
unit TrkBar;
{
***************************************************************************
*	Name:					TrkBar																										*
*	Description:	Track Bar Comopnent																				*
*	Platform:			Delphi 2.0																								*
*	Started:			21.09.96 - Delphi 1.0																			*
*	Changed:			14.03.97 - Delphi 2.0																			*
*	Tabs step:		2																													*
*	Author:				Ray Konopka																								*
*	CoAuthor:			Anatoly Podgoretsky																				*
*								Vahe 4-31, Johvi, Estonia, EE2045													*
*	email:				kvk@estpak.ee																							*
*	Copyright:		() NPS, 1996-1997																				*
*	Installation:	Copy files marked with <#> in your prefered component			*
*								directory or create new one. Then install on palette			*
*								<Component|Install>. Component installed on ADD tab.			*
*								If this tab not fine for you may change it.								*
*								look comment in Register procedure												*
*								This programm fully free and may use and distribute as		*
*								you want, except Copyright statement, this must stay			*
*								unchanged. Of couse if you modify programm you may add		*
* 							yours Portion Copyright statement below me.								*
*	Files:				Label3d.dcu		# component (compiled)											*
***************************************************************************
}
interface

uses
	Messages,
  Windows,
  Classes,
  Graphics,
  Controls,
  Menus,
  ExtCtrls;
type
	TTrackOrientation	=	(toHorizontal,toVertical);
  TThumbSize				=	(tsSize1,tsSize2,tsSize3,tsSize4,tsSize5);
  TThumbStyle				=	(tsBox,tsCircle,tsDiamond,tsPointer,tsSquare);
  TTickStyle				=	(tkStandard,tkOwnerDraw);

  TTrkBar	=	class;																// Forward reference
  TDrawTickEvent	=	procedure(TrkBar:TTrkBar;
  														Canvas:TCanvas;
                              Location:TPoint;
                              Index:Integer) of object;
  TTrkBar	=	class(TCustomControl)
  	private
    		{TrkBar}
    	FBorderWidth		:	Integer;
    	FMax						:	Integer;
    	FMin						:	Integer;
      FOrientation		:	TTrackOrientation;
      FPageSize				:	Word;
    	FPosition				:	Integer;
      FTickStyle			:	TTickStyle;
      FTLTicks				:	Boolean;
      FBRTicks				:	Boolean;
      FSliding				:	Boolean;
				{Thumb}
      FThumbRect			:	TRect;
      FThumbStyle			:	TThumbStyle;
      FThumbSize			:	TThumbSize;
      FThumbWidth			:	Integer;
      FThumbHeight		:	Integer;
      FHalfWidth			:	Integer;
			FTHumbBmp				:	TBitmap;
			FMaskBmp				:	TBitmap;
			FBackgroundBmp	:	TBitmap;
      	{chink}
      FTrkColor				:	TColor;
      FTrkRect				:	TRect;
      FTrkWidth				:	Word;

			FDitherBmp			:	TBitmap;
      FOnChange				:	TNotifyEvent;
      FOnDrawTick			:	TDrawTickEvent;
      procedure	SetMax(Value:Integer);
      procedure	SetMin(Value:Integer);
      procedure	SetOrientation(Value:TTrackOrientation);
      procedure	SetPosition(Value:Integer);
      procedure	SetTLTicks(Value:Boolean);
      procedure	SetBRTicks(Value:Boolean);
      procedure	SetThumbSize(Value:TThumbSize);
      procedure	SetThumbStyle(Value:TThumbStyle);
      procedure	SetTickStyle(Value:TTickStyle);
      procedure	SetTrkWidth(Value:Word);
      procedure	SetTrkColor(Value:TColor);
      procedure	LoadThumbBitmaps;
      procedure	UpdateDitherBitmap;
      procedure	WMGetDlgCode(var Msg:TWMGetDlgCode); message wm_GetDlgCode;
      procedure	WMSize(var Msg:TWMSize); message wm_Size;
      procedure	CMEnabledChanged(var Msg:TMessage); message cm_EnabledChanged;
		protected
      procedure	DrawTrk;		virtual;
      procedure	DrawTicks;	virtual;
      procedure	DrawThumb;	virtual;
      procedure	Paint;			override;
      procedure	Change;			dynamic;
      procedure	DrawTick(	Canvas:TCanvas;
      										Location:TPoint;
                          Index:Integer); dynamic;
      procedure	DoEnter;	override;
      procedure	DoExit;		override;
      procedure	KeyDown(	var Key:Word;
      										Shift:TShiftState); override;
      procedure	MouseDown(Button:TMouseButton;
      										Shift:TShiftState;
                          X,Y:Integer); override;
      procedure	MouseMove(Shift:TShiftState;
                          X,Y:Integer); override;
      procedure	MouseUp(	Button:TMouseButton;
      										Shift:TShiftState;
                          X,Y:Integer); override;
    public
    	constructor Create(AOwner:TComponent); override;
    	destructor Destroy; override;
    published
    	property	Max:Integer						read FMax
      																write SetMax
                                      default 10;
    	property	Min:Integer						read FMin
      																write SetMin
                                      default 0;
    	property	Orientation : TTrackOrientation
      																read FOrientation
      																write SetOrientation
                                      default toHorizontal;
    	property	PageSize : Word				read FPageSize
      																write FPageSize
                                      default 1;
    	property	Position : Integer		read FPosition
      																write SetPosition;
    	property	TLTicks : Boolean			read FTLTicks
      																write SetTLTicks
                                      default True;
    	property	BRTicks : Boolean			read FBRTicks
      																write SetBRTicks
                                      default False;
    	property	ThumbSize : TThumbSize
      																read FThumbSize
      																write SetThumbSize
      																default tsSize3;
    	property	ThumbStyle:TThumbStyle
      																read FThumbStyle
      																write SetThumbStyle
	    																default tsPointer;
    	property	TickStyle : TTickStyle
      																read FTickStyle
      																write SetTickStyle
	    																default tkStandard;
    	property	TrkColor : TColor			read FTrkColor
      																write SetTrkColor
	    																default clWhite;
    	property	TrkWidth : Word				read FTrkWidth
      																write SetTrkWidth
	    																default 8;
    	property	OnChange : TNotifyEvent	read FOnChange
      																write FOnChange;
    	property	OnDrawTick : TDrawTickEvent
      																read FOnDrawTick
      																write FOnDrawTick;
      			{ inheritted property and events }
    	property	Color;
    	property	DragCursor;
    	property	DragMode;
    	property	Enabled;
    	property	HelpContext;
    	property	Hint;
    	property	ParentShowHint;
    	property	PopupMenu;
    	property	ShowHint;
    	property	TabOrder;
    	property	TabStop	default True;
    	property	Visible;

    	property	OnClick;
    	property	OnDragDrop;
    	property	OnDragOver;
    	property	OnEndDrag;
    	property	OnEnter;
    	property	OnExit;
    	property	OnKeyDown;
    	property	OnKeyPress;
    	property	OnKeyUp;
    	property	OnMouseDown;
    	property	OnMouseMove;
    	property	OnMouseUp;
  end;	//	TTrkBar

  procedure Register;

implementation

{$R TRKBAR.RES}

uses
	Drw3dBrd;
const
	TBoxBitmapNames			:	array[TTrackOrientation,TThumbSize] of PChar =
   (('BOX_HSIZE1','BOX_HSIZE2','BOX_HSIZE3','BOX_HSIZE4','BOX_HSIZE5'),
	  ('BOX_VSIZE1','BOX_VSIZE2','BOX_VSIZE3','BOX_VSIZE4','BOX_VSIZE5'));
	TBoxMaskNames				:	array[TTrackOrientation,TThumbSize] of PChar =
   (('BOX_HSIZE1M','BOX_HSIZE2M','BOX_HSIZE3M','BOX_HSIZE4M','BOX_HSIZE5M'),
	  ('BOX_VSIZE1M','BOX_VSIZE2M','BOX_VSIZE3M','BOX_VSIZE4M','BOX_VSIZE5M'));
	TCircleBitmapNames	:	array[TThumbSize] of PChar =
    ('CIRCLE_SIZE1','CIRCLE_SIZE2','CIRCLE_SIZE3','CIRCLE_SIZE4','CIRCLE_SIZE5');
	TCircleMaskNames		:	array[TThumbSize] of PChar =
    ('CIRCLE_SIZE1M','CIRCLE_SIZE2M','CIRCLE_SIZE3M','CIRCLE_SIZE4M','CIRCLE_SIZE5M');
	TDiamondBitmapNames	:	array[TThumbSize] of PChar =
		('DIAMOND_SIZE1','DIAMOND_SIZE2','DIAMOND_SIZE3','DIAMOND_SIZE4','DIAMOND_SIZE5');
	TDiamondMaskNames		:	array[TThumbSize] of PChar =
		('DIAMOND_SIZE1M','DIAMOND_SIZE2M','DIAMOND_SIZE3M','DIAMOND_SIZE4M','DIAMOND_SIZE5M');
	TPointerBitmapNames	:	array[TTrackOrientation,TThumbSize] of PChar =
  	(('POINTER_HSIZE1','POINTER_HSIZE2','POINTER_HSIZE3','POINTER_HSIZE4','POINTER_HSIZE5'),
  	 ('POINTER_VSIZE1','POINTER_VSIZE2','POINTER_VSIZE3','POINTER_VSIZE4','POINTER_VSIZE5'));
	TPointerMaskNames		:	array[TTrackOrientation,TThumbSize] of PChar =
  	(('POINTER_HSIZE1M','POINTER_HSIZE2M','POINTER_HSIZE3M','POINTER_HSIZE4M','POINTER_HSIZE5M'),
  	 ('POINTER_VSIZE1M','POINTER_VSIZE2M','POINTER_VSIZE3M','POINTER_VSIZE4M','POINTER_VSIZE5M'));
	TSquareBitmapNames	:	array[TThumbSize] of PChar =
    ('SQUARE_SIZE1','SQUARE_SIZE2','SQUARE_SIZE3','SQUARE_SIZE4','SQUARE_SIZE5');
// const
{***************************
 *	Constructor - init all *
 ***************************}
constructor TTrkBar.Create(AOwner:TComponent);
begin
	inherited Create(AOwner);
  Width							:=	200;
  Height						:=	50;
  FTrkWidth					:=	8;
  FOrientation			:=	toHorizontal;
  FTrkColor					:=	clWhite;
  FMin							:=	0;
  FMax							:=	10;
  FPosition					:=	0;
  FBorderWidth			:=	4;
  FPageSize					:=	1;
  TabStop						:=	True;
  FTLTicks					:=	True;
  FBRTicks					:=	False;
  FSliding					:=	False;
  FThumbBmp					:=	TBitmap.Create;
  FMaskBmp					:=	TBitmap.Create;
  FBackgroundBmp		:=	TBitmap.Create;
  FThumbStyle				:=	tsPointer;
  FThumbSize				:=	tsSize3;
  FDitherBmp				:=	TBitmap.Create;
  FDitherBmp.Width	:=	8;
  FDitherBmp.Height	:=	8;
  UpdateDitherBitmap;
  LoadThumbBitmaps;
end;	// Create
{**************************
 *	Destructor - free all *
 **************************}
destructor TTrkBar.Destroy;
begin
	FDitherBmp.Free;
	FThumbBmp.Free;
	FMaskBmp.Free;
	FBackgroundBmp.Free;
  inherited Destroy;
end;	//  Destroy
{*********************
 *	Change Max value *
 *********************}
procedure TTrkBar.SetMax(Value:Integer);
begin
	if Value <> FMax then begin
  	FMax	:=	Value;
    if FPosition > FMax then Position	:= FMax;		// limit
    Invalidate;
  end;
end;	//	SetMax
{*********************
 *	Change Min value *
 *********************}
procedure TTrkBar.SetMin(Value:Integer);
begin
	if Value <> FMin then begin
  	FMin	:=	Value;
    if FPosition < FMin then Position	:= FMin;	// limit
    Invalidate;
  end;
end;	//	SetMin
{************************
 *	Change orientation	*
 ************************}
procedure TTrkBar.SetOrientation(Value:TTrackOrientation);
begin
	if Value <> FOrientation then begin
  	FOrientation	:=	Value;
    LoadThumbBitmaps;
    Invalidate;
  end;
end;	//	SetOrientation
{**************************
 *	Change thumb position	*
 **************************}
procedure TTrkBar.SetPosition(Value:Integer);
begin
	if Value <> FPosition then begin
  	if Value < FMin then Value :=FMin							// check range
    else begin
    	if Value > FMax then Value := FMax;
    end;
		FPosition :=	Value;
    if csDesigning in ComponentState then
    	Invalidate
    else begin																		// clear old by draw backgrounf
    	Canvas.Draw(FThumbRect.Left,FThumbRect.Top,FBackgroundBmp);
      DrawThumb;																	// draw in new position
      Change;																			// toggle event OnChange
    end;
	end;
end;	//	SetPosition
{********************
 *	On-Off TOP-LEFT	*
 ********************}
procedure TTrkBar.SetTLTicks(Value:Boolean);
begin
	if Value <> FTLTicks then begin
  	FTLTicks :=	Value;
    Invalidate;
  end;
end;	//	SetTLTicks
{************************
 *	On-Off RIGHT-BOTTOM	*
 ************************}
procedure TTrkBar.SetBRTicks(Value:Boolean);
begin
	if Value <> FBRTicks then begin
  	FBRTicks :=	Value;
    Invalidate;
  end;
end;	//	SetBRTicks
{**********************
 *	Change thumb size *
 **********************}
procedure TTrkBar.SetThumbSize(Value:TThumbSize);
begin
	if Value <> FThumbSize then begin
  	FThumbSize	:=	Value;
    LoadThumbBitmaps;															// load new image
    Invalidate;
  end;
end;	//	SetThumbSize
{***********************
 *	Change thumb style *
 ***********************}
procedure TTrkBar.SetThumbStyle(Value:TThumbStyle);
begin
	if Value <> FThumbStyle then begin
  	FThumbStyle	:=	Value;
    LoadThumbBitmaps;															// load new image
    Invalidate;
  end;
end;	//	SetThumbStyle
{**********************
 *	Change tick style *
 **********************}
procedure TTrkBar.SetTickStyle(Value:TTickStyle);
begin
	if Value <> FTickStyle then begin
  	FTickStyle	:=	Value;
    Invalidate;
  end;
end;	//	SetTickStyle
{****************************
 *	Change Track Bar Color	*
 ****************************}
procedure TTrkBar.SetTrkColor(Value:TColor);
begin
	if Value <> FTrkColor then begin
  	FTrkColor	:=	Value;
    UpdateDitherBitmap;
    Invalidate;
  end;
end;	//	SetTrkColor
{********************************************
 *	Change Track Bar Widht and check range	*
 ********************************************}
procedure TTrkBar.SetTrkWidth(Value:Word);
begin
	if Value <> FTrkWidth then begin
  	FTrkWidth	:=	Value;
    if FTrkWidth < 6 then FTrkWidth := 6;					// limit
    Invalidate;
  end;
end;	//	SetTrkWidth
{************************************************
 *	Load Thumb Image and setup Width and Height	*
 ************************************************}
procedure TTrkBar.LoadThumbBitmaps;
begin
	case FThumbStyle of
		tsBox:
    	begin
		    FThumbBmp.Handle := LoadBitmap(HInstance,TBoxBitmapNames[FOrientation,FThumbSize]);
      end;
		tsCircle:
    	begin
		    FThumbBmp.Handle := LoadBitmap(HInstance,TCircleBitmapNames[FThumbSize]);
		    FMaskBmp.Handle	 := LoadBitmap(HInstance,TCircleMaskNames[FThumbSize]);
      end;
		tsDiamond:
    	begin
		    FThumbBmp.Handle := LoadBitmap(HInstance,TDiamondBitmapNames[FThumbSize]);
		    FMaskBmp.Handle  := LoadBitmap(HInstance,TDiamondMaskNames[FThumbSize]);
      end;
		tsPointer:
  		begin
  			FThumbBmp.Handle := LoadBitmap(HInstance,TPointerBitmapNames[FOrientation,FThumbSize]);
		  	FMaskBmp.Handle  := LoadBitmap(HInstance,TPointerMaskNames[FOrientation,FThumbSize]);
  		end;
	tsSquare:
    	begin
		    FThumbBmp.Handle := LoadBitmap(HInstance,TSquareBitmapNames[FThumbSize]);
      end;
	end;
	if FOrientation = toVertical then begin
		FThumbHeight	:=	FThumbBmp.Width;
  	FThumbWidth		:=	FThumbBmp.Height;	end
	else begin
 		FThumbHeight	:=	FThumbBmp.Height;
 		FThumbWidth		:=	FThumbBmp.Width;
	end;
  FHalfWidth := FThumbWidth div 2;
end;	//	LoadThumbBitmaps
{******************
 *	Dither Bitmap *
 ******************}
procedure TTrkBar.UpdateDitherBitmap;
var
	C	:	TColor;
  I	:	Integer;
  J	:	Integer;
begin
	C	:=	clSilver;
  if ColorToRGB(FTrkColor) = clSilver then C := clGray;
  with FDitherBmp.Canvas do begin
  	Brush.Color	:=	FTrkColor;
    FillRect(Rect(0,0,
						    	FDitherBmp.Width,
						    	FDitherBmp.Height));
    for I := 0 to 7 do begin
    	for J := 0 to 7 do begin
      	if ( I + J) mod 2 <> 0 then Pixels[I,J] := C;
      end;
    end;
	end;
end;	//	UpdateDitherBitmap
{*******************
 *	Draw Track Bar *
 *******************}
procedure TTrkBar.DrawTrk;
begin
	if FOrientation = toVertical then begin
  	FTrkRect.Top		:=	FHalfWidth + FBorderWidth;
  	FTrkRect.Bottom	:=	Height - FBorderWidth - FHalfWidth;
  	FTrkRect.Left		:=	(Width - FTrkWidth) div 2;
  	FTrkRect.Right	:=	FTrkRect.Left + FTrkWidth; end
  else begin
  	FTrkRect.Top		:=	(Height - FTrkWidth) div 2;
	  FTrkRect.Bottom	:=	FTrkRect.Top + FTrkWidth;
  	FTrkRect.Left		:=	FHalfWidth + FBorderWidth;
  	FTrkRect.Right	:=	Width - FBorderWidth - FHalfWidth;
  end;
  Canvas.Brush.Color := FTrkColor;
  if not Enabled then Canvas.Brush.Bitmap := FDitherBmp;
  Canvas.FillRect(FTrkRect);
  DrawCtl3dBorder(Canvas,FTrkRect);
end;	// DrawTrk
{**************************
 *	Draw Track Bar Ticks	*
 **************************}
procedure TTrkBar.DrawTicks;
var
	Delta	:	Real;
  I	:	Integer;
  X	:	Integer;
  Y	:	Integer;
begin
	Canvas.Pen.Color := clBlack;
  with FTrkRect do begin
		if FOrientation = toVertical then begin
			Delta := (Height - FThumbWidth - 2 * FBorderWidth) / (Fmax - FMin);
    	for I := FMin to FMax do begin
    		Y := Trunc(Delta * (I - FMin)) + FBorderWidth;
	      if FTickStyle = tkStandard then begin
        	if FTLTicks then begin
	  	    	Canvas.MoveTo(FBorderWidth,Y + FHalfWidth);
  	  	   	Canvas.LineTo(10,Y + FHalfWidth);
          end;
      	  if FBRTicks then begin
  	    		Canvas.MoveTo(Width - 10,Y + FHalfWidth);
	       		Canvas.LineTo(Width - FBorderWidth,Y + FHalfWidth);
	        end; end
  	    else begin
					DrawTick(Canvas,Point(0,Y + FHalfWidth),I);
      	end;
      end; end
	  else begin
			Delta := (Width - FThumbWidth - 2 * FBorderWidth) / (Fmax - FMin);
    	for I := FMin to FMax do begin
    		X := Trunc(Delta * (I - FMin)) + FBorderWidth;
	      if FTickStyle = tkStandard then begin
        	if FTLTicks then begin
	  	    	Canvas.MoveTo(X + FHalfWidth,FBorderWidth);
  	  	   	Canvas.LineTo(X + FHalfWidth,10);
          end;
      	  if FBRTicks then begin
  	    		Canvas.MoveTo(X + FHalfWidth,Height - 10);
	       		Canvas.LineTo(X + FHalfWidth,Height - FBorderWidth);
	        end; end
  	    else begin
					DrawTick(Canvas,Point(X + FHalfWidth,0),I);
      	end;
      end;
    end;
  end;
end;	//	DrawTicks
{****************************
 *	 TrkBar	Thumb	*
 ****************************}
procedure TTrkBar.DrawThumb;
var
	Offset		:	LongInt;
  WorkBmp		:	TBitmap;
  WorkRect	:	TRect;
begin
{ Calc left position	}
	if FOrientation = toVertical then begin
  	Offset	:=	(Longint(Height) - FThumbWidth -
    						2 * FBorderWidth) *
    						(FPosition - FMin) div (Fmax - FMin);
  	FThumbRect.Left		:=	(Width - FThumbHeight) div 2;
  	FThumbRect.Right	:=	FThumbRect.Left + FThumbHeight;
  	FThumbRect.Bottom	:=	Height - Offset - FBorderWidth;
  	FThumbRect.Top		:=	FThumbRect.Bottom - FThumbWidth; end
  else begin
  	Offset	:=	(Longint(Width) - FThumbWidth -
    						2 * FBorderWidth) *
    						(FPosition - FMin) div (Fmax - FMin);
  	FThumbRect.Left		:=	Offset + FBorderWidth;
  	FThumbRect.Right	:=	FThumbRect.Left + FThumbWidth;
  	FThumbRect.Top		:=	(Height - FThumbHeight) div 2;
	  FThumbRect.Bottom	:=	FThumbRect.Top + FThumbHeight;
  end;
{ Save background for new position	}
  FBackgroundBmp.Width	:=	FThumbBmp.Width;
  FBackgroundBmp.Height	:=	FThumbBmp.Height;
  FBackgroundBmp.Canvas.CopyRect(Rect(0,0,
  																		FThumbBmp.Width,
                                      FThumbBmp.Height),
  															 			Canvas,
                                      FThumbRect);
{	Draw thum by raster.
  WorkBmp using as union for thumb and background,
  If TThumbStyle = tsBox or tsSquare no need mask background,
  simple copy thumb on canvas}
	WorkBmp := TBitmap.Create;
  try
  	WorkBmp.Height	:=	FThumbBmp.Height;
  	WorkBmp.Width		:=	FThumbBmp.Width;
		WorkRect				:=	Rect(	0,0,
    													FThumbBmp.Width,
                              FThumbBmp.Height);
    if (FthumbStyle = tsBox) or (FthumbStyle = tsSquare) then
    	WorkBmp.Canvas.CopyMode	:=	cmSrcCopy
    else begin
    	WorkBmp.Canvas.CopyMode	:=	cmSrcCopy;
      WorkBmp.Canvas.CopyRect(WorkRect,FBackgroundBmp.Canvas,WorkRect);
    	WorkBmp.Canvas.CopyMode	:=	cmSrcAnd;
      WorkBmp.Canvas.CopyRect(WorkRect,FMaskBmp.Canvas,WorkRect);
      WorkBmp.Canvas.CopyMode	:=	cmSrcPaint;
    end;
    WorkBmp.Canvas.CopyRect(WorkRect,FThumbBmp.Canvas,WorkRect);
	  if not Enabled then begin
      WorkBmp.Canvas.Brush.Bitmap := FDitherBmp;
      WorkBmp.Canvas.FloodFill( WorkRect.Right - 3,
       													WorkRect.Bottom - 3,
                                clSilver,
                                fsSurface);
    end;
    Canvas.CopyRect(FThumbRect,WorkBmp.Canvas,WorkRect);
  finally
  	WorkBmp.Free;
  end;
end;	//	DrawThumb
{********************************
 * Draw when OnPaint activated	*
 ********************************}
procedure TTrkBar.Paint;
begin
	with Canvas do begin
  	if Focused then DrawFocusRect(ClientRect);
    DrawTrk;
    if FTLTicks or FBRTicks then DrawTicks;
    DrawThumb;
  end;
end;	// Paint
{**************************
 * Dispatch Change Event	*
 **************************}
procedure TTrkBar.Change;
begin
	if Assigned(FOnChange) then FOnChange(Self);
end;
{********************************************************
 * Dispatch OnDrawTick Event														*
 *	FOnDrawTick	- User procedure												*
 *	Parameters:																		 			*
 *		Canvas		-	canvas for draw elemets of Track Bar	*
 *		Location	-	coordinates X,Y tick									*
 *		Index			- Index of tick													*
 ********************************************************}
procedure TTrkBar.DrawTick(	Canvas:TCanvas;
														Location:TPoint;
                            Index:Integer);
begin
	if Assigned(FOnDrawTick) then FOnDrawTick(Self,Canvas,Location,Index);
end;	//	DrawTick
{**********************
 * Overrided DoEnter	*
 **********************}
procedure TTrkBar.DoEnter;
begin
	inherited DoEnter;
  Refresh;
end;	//	DoEnter
{********************
 * Overrided DoExit	*
 ********************}
procedure TTrkBar.DoExit;
begin
	inherited DoExit;
  Refresh;
end;	//	DoExit
{**********************
 * Overrided KeyDown	*
 **********************}
procedure TTrkBar.KeyDown(var Key:Word; Shift:TShiftState);
begin
	inherited KeyDown(Key,Shift);
  case Key of
  	vk_Prior:	Position := FPosition + FPageSize;	//	PgUp
    vk_Next:	Position := FPosition - FPageSize;	//	PgDn
    vk_End:		if FOrientation = toVertical then		//	End
	              Position := FMin
    					else begin
	              Position := FMax;
              end;
    vk_Home:	if FOrientation = toVertical then		//	Home
	              Position := FMax
    					else begin
	              Position := FMin;
              end;
    vk_Left,vk_Down:	if FPosition > FMin then Position := FPosition - 1;
		vk_Right,vk_Up:		if FPosition < FMax then Position := FPosition + 1;
  end;
end;	//	KeyDown
{************************
 * Overrided MouseDown	*
 ************************}
procedure TTrkBar.MouseDown(Button:TMouseButton;
														Shift:TShiftState;
                            X,Y:Integer);
var
	PtX		:	Integer;
	PtY		:	Integer;
  Delta	:	Real;
begin
	inherited MouseDown(Button,Shift,X,Y);
  if (Button = mbLeft) then begin											// only for Left Key
  	if PtInRect(FThumbRect,Point(X,Y)) then						// if in Thumb
	  	FSliding	:= True																// swithc on sliding mode
  	else if PtInRect(FTrkRect,Point(X,Y)) then begin	// if in chink move thumb
    	if FOrientation = toVertical then begin
      	Delta := (Height - FThumbWidth - 2 * FBorderWidth) / (FMax - FMin);
        PtY	:=	Trunc(Delta * ((FMax - FPosition) - FMin)) + FBorderWidth;
        if Y < PtY then
        	Position := FPosition + FPageSize
        else begin
        	Position := FPosition - FPageSize
        end; end
      else begin
      	Delta := (Width - FThumbWidth - 2 * FBorderWidth) / (FMax - FMin);
        PtX	:=	Trunc(Delta * ((FPosition) - FMin)) + FBorderWidth;
        if X < PtX then
        	Position := FPosition - FPageSize
        else begin
        	Position := FPosition + FPageSize;
        end;
      end;
    end;
  end;
end;	//	MouseDown
{************************
 * Overrided MouseMove	*
 ************************}
procedure TTrkBar.MouseMove(Shift:TShiftState; X,Y:Integer);
var
	P	:	Integer;
	W	:	Integer;
	H	:	Integer;
begin
	inherited MouseMove(Shift,X,Y);
  if PtInRect(FThumbRect,Point(X,Y)) then begin		// if in Thumb
  	if FOrientation = toVertical then
	  	Cursor	:=	crSizeNS												// |
  	else begin
  		Cursor	:=	crSizeWE;												// <=>
	  end; end
  else begin
 		Cursor	:=	crDefault;
  end;
  if FSliding then begin
  	if FOrientation = toVertical then begin
    	H	:=	Height - FHalfWidth;
      P	:=	Round(((H - Y) / H) * (FMax - FMin) + FMin); end
    else begin
    	W	:=	Width - FHalfWidth;
      P	:=	Round(((X - FHalfWidth) / W) * (FMax - FMin) + FMin);
    end;
	  if P > FMax then P := FMax;
  	if P < FMin then P := FMin;
	  Position	:=	P;
  end;
end;	//	MouseMove
{**********************
 * Overrided MouseUp	*
 **********************}
procedure TTrkBar.MouseUp(Button:TMouseButton;
													Shift:TShiftState;
                          X,Y:Integer);
begin
	inherited MouseUp(Button,Shift,X,Y);
  if (Button = mbLeft) then	FSliding	:= False;		// switch off sliding mode
end;	//	MouseUp
{******************************************
 * Wanted get messages abount arrow keys	*
 *       *
 ****************************************************}
procedure TTrkBar.WMGetDlgCode(var Msg:TWMGetDlgCode);
begin
	inherited;
  Msg.Result := dlgc_WantArrows;
end;	//	WMGetDlgCode
{************************
 * Window Message Size	*
 ************************}
procedure TTrkBar.WMSize(var Msg:TWMSize);
begin
	inherited;
  if Height > Width then
  	Orientation := toVertical
  else begin
  	Orientation := toHorizontal;
  end
end;	//	WMSize
{*************************************
 * Reaction for change state Enabled *
 *************************************}
procedure TTrkBar.CMEnabledChanged(var Msg:TMessage);
begin
	inherited;
  Invalidate;
end;	//	CMEnabledChanged
{**********************
 * Register component	*
 **********************}
procedure Register;
begin
	RegisterComponents('Add',[TTrkBar]);
end;	//	Register

end.
